Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 312991)
+++ channels/chan_sip.c	(working copy)
@@ -25467,8 +25467,6 @@
 			res = AST_DEVICE_UNAVAILABLE;
 		}
 		unref_peer(p, "unref_peer, from sip_devicestate, release ref from find_peer");
-	} else {
-		res = AST_DEVICE_UNKNOWN;
 	}
 
 	return res;
Index: main/devicestate.c
===================================================================
--- main/devicestate.c	(revision 312991)
+++ main/devicestate.c	(working copy)
@@ -786,6 +786,7 @@
 		agg->all_free = 0;
 		break;
 	case AST_DEVICE_UNKNOWN:
+		agg->all_unavail = 0;
 		agg->all_busy = 0;
 		agg->all_free = 0;
 		break;
@@ -811,6 +812,8 @@
 		return AST_DEVICE_ONHOLD;
 	if (agg->all_busy)
 		return AST_DEVICE_BUSY;
+	if (agg->all_unknown && agg->all_unavail)
+		return AST_DEVICE_INVALID;	
 	if (agg->all_unknown)
 		return AST_DEVICE_UNKNOWN;
 	if (agg->all_unavail)
